"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request");
const Promise = require("promise");
const fs = require("fs");
const path = require("path");
const octoClient_1 = require("./octoClient");
class Octo {
    /**
     * Gets the token a save it in the generator. It should be instanciated in the server as the the product key is secret.
     * @param key the product key
     * @param username your username
     */
    constructor(key, username, pathTo) {
        /**
        * Url for the server
        */
        this.url = 'https://www.octopinion.co.uk';
        this.getAccessToken = (key, username, resolve, reject) => {
            let data = { tokenType: 'TILL', key: key };
            request.get(`${this.url}/token/${username}/`, {
                qs: data
            }, (err, httpresponse, body) => {
                if (err) {
                    reject(err);
                }
                else {
                    const response = JSON.parse(body);
                    if (!response.token) {
                        reject(response);
                    }
                    else {
                        resolve(response.token);
                    }
                }
            });
        };
        if (!pathTo) {
            pathTo = __dirname;
        }
        let pro = new Promise((resolve, reject) => {
            this.getAccessToken(key, username, resolve, reject);
        }).then((token) => {
            this.token = token;
            this.octoClient = new octoClient_1.default({ insertLastReviews: true, pageSize: 20, hideWhenNotLogged: true, disableWhenNotLogged: true }, token, username);
            fs.readFile(path.join(__dirname, '../bundle.js'), 'utf8', (error, data) => {
                const newdata = data.replace('<%= token %>', token).replace(/<%= user %>/g, username);
                fs.closeSync(fs.openSync(path.join(pathTo, './bundleBuild.js'), 'w'));
                fs.writeFile(path.join(pathTo, './bundleBuild.js'), newdata, function (err) { if (err)
                    console.error('Error creating file', err); });
            });
        }).catch((err) => {
            console.error('Get access token error', err);
        });
    }
    ;
}
exports.Octo = Octo;
exports.default = Octo;
//# sourceMappingURL=index.js.map