"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const styles_1 = require("./styles");
const React = require("react");
/**
 * Component for entering new reviews
 */
class NewReviewBox extends React.Component {
    constructor(props) {
        super(props);
        this.setText = (ev) => {
            const noloadingState = NewReviewBox.NOT_LOADING;
            noloadingState.txt = ev.target.value;
            this.setState(noloadingState);
            this.props.setText(ev.target.value);
        };
        this.analizeReview = () => {
            this.setLoadingState();
            this.props.analize().subscribe(data => {
                if (data.status !== 'OK') {
                    console.error('Something went wrong while analizing text', data);
                }
                this.props.setText('');
                this.getReviewsForInitialPage();
            }, (error) => { console.error('Analized failed', error); });
        };
        this.getReviewsForInitialPage = () => {
            this.props.getReviewsForPage(0).subscribe((data) => {
                if (this.props.parent)
                    this.props.parent.changeReviews(data);
                this.removeLoadingState();
            }, (error) => { console.error('Error while loading initial reviews'); });
        };
        this.state = NewReviewBox.NOT_LOADING;
    }
    setLoadingState() {
        this.setState(NewReviewBox.LOADING);
    }
    removeLoadingState() {
        const noloadingState = NewReviewBox.NOT_LOADING;
        noloadingState.txt = '';
        this.setState(noloadingState);
    }
    render() {
        let textarea;
        let loader;
        if (!this.props.hide) {
            textarea = React.createElement(styles_1.Textarea, { value: this.state.txt, disabled: this.props.disable, onChange: this.setText, className: "review-body", placeholder: this.props.disable ? 'Register to send reivews' : 'Your comment' });
        }
        if (this.state.loading) {
            loader = React.createElement("div", { id: "loading" },
                React.createElement(styles_1.Loader, null));
        }
        return (React.createElement(styles_1.Comment, { className: "review" },
            React.createElement("div", { className: "comment-header" },
                React.createElement("a", { href: "javascript: void(0);", onClick: this.analizeReview },
                    React.createElement("i", { className: "fa fa-paper-plane-o fa-2x", "aria-hidden": "true" }))),
            textarea,
            loader));
    }
}
NewReviewBox.LOADING = { loading: true };
NewReviewBox.NOT_LOADING = { loading: false, txt: '' };
;
exports.default = NewReviewBox;
//# sourceMappingURL=newReviewBox.js.map