"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const styles_1 = require("./styles");
const React = require("react");
/**
 * Paginating component
 */
class OlderReviewsBox extends React.Component {
    constructor(props) {
        super(props);
        this.addMore = () => {
            this.setState(OlderReviewsBox.LOADING);
            this.props.addMore().subscribe((data) => {
                this.setState(OlderReviewsBox.NOT_LOADING);
                this.props.parent.addReviews(data);
            }, (error) => {
                console.error('Error while loading more reviews');
            });
        };
        this.getReviewsForPage = (page) => {
            this.setState(OlderReviewsBox.LOADING);
            this.props.getReviewsForPage(page).subscribe((data) => {
                this.setState(OlderReviewsBox.NOT_LOADING);
                this.props.parent.changeReviews(data);
            }, (error) => {
                console.error('Error while loading more reviews');
            });
        };
        this.state = OlderReviewsBox.NOT_LOADING;
    }
    render() {
        let nextButton;
        let lastButton;
        let firstButton;
        let previousButton;
        let showMoreButton;
        if (this.props.showMoreApproach && (this.props.paging.currentPage < this.props.paging.lastPage)) {
            showMoreButton = React.createElement("a", { href: "javascript: void(0);", onClick: this.addMore }, this.state.loading ?
                React.createElement("i", { className: 'fa fa-refresh fa-2x', "aria-hidden": "true" }) : React.createElement(styles_1.RefreshIcon, { className: 'fa fa-refresh fa-2x', "aria-hidden": "true" }));
        }
        else if (!this.props.showMoreApproach) {
            if (this.props.paging.currentPage + 1 < this.props.paging.lastPage) {
                nextButton = React.createElement("a", { href: "javascript: void(0);", onClick: () => this.getReviewsForPage(this.props.paging.currentPage + 1) },
                    React.createElement("i", { className: "fa fa-forward fa-2x", "aria-hidden": "true" }));
            }
            if (this.props.paging.currentPage > 1) {
                previousButton = React.createElement("a", { href: "javascript: void(0);", onClick: () => this.getReviewsForPage(this.props.paging.currentPage - 1) },
                    React.createElement("i", { className: "fa fa-backward fa-2x", "aria-hidden": "true" }));
            }
            if (this.props.paging.currentPage < this.props.paging.lastPage) {
                lastButton = React.createElement("a", { href: "javascript: void(0);", onClick: () => this.getReviewsForPage(this.props.paging.lastPage) },
                    React.createElement("i", { className: "fa fa-fast-forward fa-2x", "aria-hidden": "true" }));
            }
            if (this.props.paging.currentPage > 0) {
                firstButton = React.createElement("a", { href: "javascript: void(0);", onClick: () => this.getReviewsForPage(0) },
                    React.createElement("i", { className: "fa fa-fast-backward fa-2x", "aria-hidden": "true" }));
            }
        }
        return (React.createElement("div", { className: "reviews-pageable" },
            firstButton,
            previousButton,
            nextButton,
            lastButton,
            showMoreButton));
    }
}
OlderReviewsBox.LOADING = { loading: true };
OlderReviewsBox.NOT_LOADING = { loading: false };
;
exports.default = OlderReviewsBox;
//# sourceMappingURL=olderReviewsBox.js.map