"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const newReviewBox_1 = require("./newReviewBox");
const reviewLine_1 = require("./reviewLine");
const olderReviewsBox_1 = require("./olderReviewsBox");
/**
 * Main component holding last reviews and textarea for entering new reviews
 */
class ReviewBox extends React.Component {
    constructor(props) {
        super(props);
        this.state = { reviews: props.data };
    }
    addReviews(reviewsData) {
        this.setState({ reviews: this.state.reviews.concat(reviewsData.content) });
    }
    changeReviews(reviewsData) {
        this.setState({ reviews: reviewsData.content });
    }
    render() {
        const dateFormat = this.props.dateFormat;
        return (React.createElement("div", { className: "reviews-box" },
            React.createElement(newReviewBox_1.default, { parent: this, disable: this.props.disableTextArea, hide: this.props.hideTextArea, setText: this.props.setText, analize: this.props.analize, getReviewsForPage: this.props.getReviewsForPage }),
            this.state.reviews.map(function (review) {
                return React.createElement(reviewLine_1.default, { key: review.id, name: review.userkey, date: review.creationDate, text: review.processedtext, dateFormat: dateFormat });
            }),
            React.createElement(olderReviewsBox_1.default, { parent: this, addMore: this.props.addMore, getReviewsForPage: this.props.getReviewsForPage, paging: this.props.paging, showMoreApproach: this.props.showMoreApproach })));
    }
}
;
exports.default = ReviewBox;
//# sourceMappingURL=reviewBox.js.map