import { Loader, Textarea, Comment, RefreshIcon } from './styles';
import * as React from 'react';
import * as moment from 'moment';
import NewReviewBox from './newReviewBox';
import ReviewLine from './reviewLine';
import OlderReviewsBox from './olderReviewsBox';

/**
 * Main component holding last reviews and textarea for entering new reviews
 */
class ReviewBox extends React.Component<ReviewBoxProps, ReviewBoxState>{
    
    public constructor(props: ReviewBoxProps) {
        super(props);
        this.state = {reviews: props.data };
    }

    public addReviews(reviewsData: AnalizedsPage){
        this.setState({ reviews: this.state.reviews.concat(reviewsData.content) });
    }

    public changeReviews(reviewsData: AnalizedsPage){
        this.setState({ reviews: reviewsData.content });
    }

    public render() {
        const dateFormat = this.props.dateFormat;
        return (
            <div className="reviews-box">
                <NewReviewBox  parent={this} disable={this.props.disableTextArea} hide={this.props.hideTextArea} setText={this.props.setText} analize={this.props.analize} getReviewsForPage={this.props.getReviewsForPage} />
                {this.state.reviews.map(function (review: Review) {
                    return <ReviewLine key={review.id} name={review.userkey} date={review.creationDate} text={review.processedtext} dateFormat={dateFormat} />;
                })
                }
                <OlderReviewsBox parent={this} addMore={this.props.addMore} getReviewsForPage={this.props.getReviewsForPage} paging={this.props.paging} showMoreApproach={this.props.showMoreApproach} />
            </div>
        );
    }
};

export default ReviewBox;
