var chai = require('chai');
var should = chai.should();
var expect = chai.expect;

var ConnectionParams = require('../dist/connectionParams');

describe('Octo Connection Params', function () {
    it('Is creating a correct json', function (done) {
        const connectionParams = new ConnectionParams.ConnectionParams('my_user', 1234);
        const connectionParamObj = JSON.parse(connectionParams.toJson());
        expect(connectionParamObj.user).to.be.eq('my_user');
        expect(connectionParamObj.identifier).to.be.eq(1234);
        done();
    });

    it('Is throwing an error when user is not defined', function (done) {
        const connectionParams = new ConnectionParams.ConnectionParams('my_user', 1234);
        connectionParams.user = undefined;
        try {
            connectionParams.toJson();
        } catch (e) {
            done();
        }
    });
});